import { ascending } from 'd3';

// const array = ['A', 'B', 1];
// array.push('C');
// console.log(array);
const range = (n) => {
  const array = [];
  for (let i = 0; i < n; i++) {
    array.push(i);
  }
  return array;
};
// console.log(range(10));

const myRange = range(10);
myRange.forEach((d) => {
  // each element in array = d (datum)
  //console.log(d);
});

// console.log(
//   myRange.filter((d) => d % 2 == 0)
// );

const newArray = [4, 1, 3, 5, 1, 6, 20];
//console.log(newArray);
//console.log(newArray.sort()); // default is to convert items to strings and then sort
//console.log(newArray); // sort() mutates the array - permanently changes it
//newArray.sort().reverse(); // sort descending

//newArray.sort((a, b) => a - b);
newArray.sort((a, b) =>
  a < b ? -1 : b > a ? 1 : 0
); // sort ascending, treated as numbers
//console.log(newArray);

// with d3 - need to import
//console.log(newArray.sort(ascending));
//console.log(newArray.sort(descending));

// console.log(myRange.map((d) => d * 2));
// console.log(myRange.map((d) => ({number : d, double : d * 2})));

console.log(
  myRange.reduce(
    (accumulator, d) => accumulator + d
  )
);

const entries = [
  { key: 'A', value: 'foo' },
  { key: 'C', value: 'baz' },
  { key: 'B', value: 'bar' },
];

console.log(
  entries.reduce((accumulator, d) => {
    accumulator[d.key] = d.value;
    return accumulator;
  }, {})
);

console.log(
  entries.sort((a, b) => (a.key < b.key ? -1 : 1))
);

// d3
console.log(entries.sort((a, b) => ascending(a.key, b.key)));

// const result = {
//   A: 'foo',
//   B: 'bar',
// };
